poj 3126 PrimePath

Prime Path
Time Limit: 1000MSMemory Limit: 65536K
Total Submissions: 11835Accepted: 6721

Description

poj <wbr>3126 <wbr>PrimePathThe ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input


1033 8179 
1373 8017 
1033 1033

Sample Output



0
 
 
#include 
#include 
#include 
using namespace std;

int num[4],tar[4], flag[10010], m, n;  //虽然flag只是标记从1000-9999的,但是!!!它最大是9999啊!虽然0-1000没用着,但是分配内存是还是有他们的啊亲!!!不然用c++就re。。。
typedef struct node
{
    int a[4], d;
}node;

int su(int x)
{
    int i;
    if(x == 2 || x == 3)
        return 1;
   if(x <= 1 || x % 2 == 0)
        return 0;
    for(i = 3 ; i*i <= x ; i+=2)
        if(x%i == 0)
            return 0;
    return 1;
}

int bfs()
{
    int i, j, k;
    queueq;
    node u;
    for(i = 0 ; i < 4 ; i++)
        u.a[i] = num[i];
    u.d = 0;
    flag[m] = 1;
    q.push(u);
    while(!q.empty())
    {
        node v;
        int x;
        u = q.front();
        //printf("%d%d%d%d,%d  ", u.a[0], u.a[1], u.a[2], u.a[3], u.d);
        if(u.a[0] == tar[0] && u.a[1] == tar[1] && u.a[2] == tar[2] && u.a[3] == tar[3])
            return u.d;
        q.pop();
        for(i = 0 ; i < 4 ; i++)
        {
            for(k = 0 ; k < 4 ; k++)
                    v.a[k] = u.a[k];
            for(j = -u.a[i] ; j <= (9 - u.a[i]) ; j++)
            {
                if(j == 0 || (i == 0 && u.a[i] + j == 0)  )
                    continue;
                v.a[i] = u.a[i] + j;
                v.d = u.d + 1;
                 x = v.a[0]*1000+v.a[1]*100+v.a[2]*10+v.a[3];
                if(su(x) && !flag[x])
                 {
                     //printf("i:%d j:%d x:%d\n",i, j, x);
                     q.push(v);
                     //printf("%d\n", x);
                     //printf("%d %d %d %d\n",v.a[0],v.a[1],v.a[2],v.a[3]);
                     flag[x] = 1;
                 }
            }
        }
    }
    return -1;
}

int main()
{
    int t, s, i;
    scanf("%d", &t);
    while(t--)
    {
        for(i = 1000 ; i <= 10000 ; i++)
            flag[i]=0;
        scanf("%d %d", &m, &n);
        for(i = 3 ; i >= 0 ; i--)
        {
            num[i] = m;
            m = m/10;
        }
        for(i = 3 ; i >= 0 ; i--)
        {
            tar[i] = n;
            n = n/10;
        }
        s = bfs();
        if(s >= 0)
            printf("%d\n", s);
        else
            printf("Impossible\n");
            //scanf("%d", &i);
            //printf("%d\n", su(i));
    }
    return 0;
}



  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值